##// END OF EJS Templates
a
Unknown -
r533:e51fb5f4a907
parent child
Show More
@@ -1,876 +1,876
1 1 #!/bin/sh
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 5 # Advanced Debian "stretch" and "buster" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 42 # Raspberry Pi model configuration
43 43 RPI_MODEL=${RPI_MODEL:=2}
44 44
45 45 # Debian release
46 46 RELEASE=${RELEASE:=buster}
47 47
48 48 # Kernel Branch
49 49 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
50 50
51 51 # URLs
52 52 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
53 53 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
54 54 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
55 55 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
56 56 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
57 57 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
58 58 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
59 59 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
60 60 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
61 61 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
62 62
63 63
64 64 # Kernel deb packages for 32bit kernel
65 65 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
66 66 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
67 67 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
68 68 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.14.80.20181113/bcmrpi3-kernel-bis-4.14.80.20181113.tar.xz}
69 69 # Default precompiled 64bit kernel
70 70 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.14.80.20181113/bcmrpi3-kernel-4.14.80.20181113.tar.xz}
71 71 # Generic
72 72 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
73 73 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
74 74 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
75 75
76 76 # Build directories
77 77 WORKDIR=$(pwd)
78 78 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
79 79 BUILDDIR="${BASEDIR}/build"
80 80
81 81 # Chroot directories
82 82 R="${BUILDDIR}/chroot"
83 83 ETC_DIR="${R}/etc"
84 84 LIB_DIR="${R}/lib"
85 85 BOOT_DIR="${R}/boot/firmware"
86 86 KERNEL_DIR="${R}/usr/src/linux"
87 87 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
88 88 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
89 89
90 90 # Firmware directory: Blank if download from github
91 91 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
92 92
93 93 # General settings
94 94 SET_ARCH=${SET_ARCH:=32}
95 95 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
96 96 PASSWORD=${PASSWORD:=raspberry}
97 97 USER_PASSWORD=${USER_PASSWORD:=raspberry}
98 98 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
99 99 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
100 100 EXPANDROOT=${EXPANDROOT:=true}
101 101
102 102 # Keyboard settings
103 103 XKB_MODEL=${XKB_MODEL:=""}
104 104 XKB_LAYOUT=${XKB_LAYOUT:=""}
105 105 XKB_VARIANT=${XKB_VARIANT:=""}
106 106 XKB_OPTIONS=${XKB_OPTIONS:=""}
107 107
108 108 # Network settings (DHCP)
109 109 ENABLE_DHCP=${ENABLE_DHCP:=true}
110 110
111 111 # Network settings (static)
112 112 NET_ADDRESS=${NET_ADDRESS:=""}
113 113 NET_GATEWAY=${NET_GATEWAY:=""}
114 114 NET_DNS_1=${NET_DNS_1:=""}
115 115 NET_DNS_2=${NET_DNS_2:=""}
116 116 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
117 117 NET_NTP_1=${NET_NTP_1:=""}
118 118 NET_NTP_2=${NET_NTP_2:=""}
119 119
120 120 # APT settings
121 121 APT_PROXY=${APT_PROXY:=""}
122 122 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
123 123
124 124 # Feature settings
125 125 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
126 126 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
127 127 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
128 128 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
129 129 ENABLE_I2C=${ENABLE_I2C:=false}
130 130 ENABLE_SPI=${ENABLE_SPI:=false}
131 131 ENABLE_IPV6=${ENABLE_IPV6:=true}
132 132 ENABLE_SSHD=${ENABLE_SSHD:=true}
133 133 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
134 134 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
135 135 ENABLE_SOUND=${ENABLE_SOUND:=true}
136 136 ENABLE_DBUS=${ENABLE_DBUS:=true}
137 137 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
138 138 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
139 139 ENABLE_XORG=${ENABLE_XORG:=false}
140 140 ENABLE_WM=${ENABLE_WM:=""}
141 141 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
142 142 ENABLE_USER=${ENABLE_USER:=true}
143 143 USER_NAME=${USER_NAME:="pi"}
144 144 ENABLE_ROOT=${ENABLE_ROOT:=false}
145 145 ENABLE_QEMU=${ENABLE_QEMU:=false}
146 146 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
147 147
148 148 # SSH settings
149 149 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
150 150 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
151 151 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
152 152 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
153 153 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
154 154
155 155 # Advanced settings
156 156 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
157 157 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
158 158 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
159 159 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
160 160 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
161 161 ENABLE_UBOOTUSB=${ENABLE_UBOOTUSB=false}
162 162 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
163 163 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
164 164 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
165 165 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
166 166 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
167 167 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
168 168 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
169 169 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
170 170 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
171 171 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
172 172 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
173 173 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
174 174
175 175 # Kernel compilation settings
176 176 BUILD_KERNEL=${BUILD_KERNEL:=true}
177 177 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
178 178 KERNEL_THREADS=${KERNEL_THREADS:=1}
179 179 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
180 180 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
181 181 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
182 182 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
183 183 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
184 184 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
185 185 KERNEL_VIRT=${KERNEL_VIRT:=false}
186 186 KERNEL_BPF=${KERNEL_BPF:=false}
187 187 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=powersave}
188 188 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
189 189 KERNEL_NF=${KERNEL_NF:=false}
190 190
191 191 # Kernel compilation from source directory settings
192 192 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
193 193 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
194 194 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
195 195 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
196 196
197 197 # Reduce disk usage settings
198 198 REDUCE_APT=${REDUCE_APT:=true}
199 199 REDUCE_DOC=${REDUCE_DOC:=true}
200 200 REDUCE_MAN=${REDUCE_MAN:=true}
201 201 REDUCE_VIM=${REDUCE_VIM:=false}
202 202 REDUCE_BASH=${REDUCE_BASH:=false}
203 203 REDUCE_HWDB=${REDUCE_HWDB:=true}
204 204 REDUCE_SSHD=${REDUCE_SSHD:=true}
205 205 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
206 206
207 207 # Encrypted filesystem settings
208 208 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
209 209 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
210 210 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
211 211 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
212 212 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
213 213 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
214 214 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
215 215 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
216 216 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
217 217
218 218 # Chroot scripts directory
219 219 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
220 220
221 221 # Packages required in the chroot build environment
222 222 APT_INCLUDES=${APT_INCLUDES:=""}
223 223 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
224 224
225 225 # Packages to exclude from chroot build environment
226 226 APT_EXCLUDES=${APT_EXCLUDES:=""}
227 227
228 228 # Packages required for bootstrapping
229 229 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo netselect-apt"
230 230 MISSING_PACKAGES=""
231 231
232 232 # Packages installed for c/c++ build environment in chroot (keep empty)
233 233 COMPILER_PACKAGES=""
234 234
235 235 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
236 236 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
237 237 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
238 238 APT_PROXY=http://127.0.0.1:3142/
239 239 fi
240 240
241 241 # netselect-apt does not know buster yet
242 242 if [ "$RELEASE" = "buster" ] ; then
243 243 RLS=testing
244 244 else
245 245 RLS="$RELEASE"
246 246 fi
247 247
248 248 if [ -f "$(pwd)/files/apt/sources.list" ] ; then
249 249 rm "$(pwd)/files/apt/sources.list"
250 250 fi
251 251
252 252 if [ "$ENABLE_NONFREE" = true ] ; then
253 253 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --nonfree --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
254 254 else
255 255 netselect-apt --arch "$RELEASE_ARCH" -t 3 --sources --outfile "$(pwd)/files/apt/sources.list" -d "$RLS"
256 256 fi
257 257
258 258 # sed and cut the result string so we can use it as APT_SERVER
259 259 APT_SERVER=$(grep -m 1 http files/apt/sources.list | sed "s|http://| |g" | cut -d ' ' -f 3 | sed 's|/$|''|')
260 260
261 261 # make script easier and more stable to use with convenient setup switch. Just setup SET_ARCH and RPI_MODEL and your good to go!
262 262 if [ -n "$SET_ARCH" ] ; then
263 263 # 64-bit configuration
264 264 if [ "$SET_ARCH" = 64 ] ; then
265 265 # General 64-bit depended settings
266 266 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
267 267 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
268 268 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
269 269
270 270 # Raspberry Pi model specific settings
271 271 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
272 272 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
273 273 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
274 274 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
275 275 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
276 276 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
277 277 else
278 278 echo "error: Only Raspberry PI 3 and 3B+ support 64-bit"
279 279 exit 1
280 280 fi
281 281 fi
282 282
283 283 # 32-bit configuration
284 284 if [ "$SET_ARCH" = 32 ] ; then
285 285 # General 32-bit dependend settings
286 286 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
287 287 KERNEL_ARCH=${KERNEL_ARCH:=arm}
288 288 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
289 289
290 290 # Raspberry Pi model specific settings
291 291 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
292 292 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
293 293 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
294 294 RELEASE_ARCH=${RELEASE_ARCH:=armel}
295 295 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
296 296 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
297 297 fi
298 298
299 299 # Raspberry Pi model specific settings
300 300 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
301 301 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
302 302 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
303 303 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
304 304 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
305 305 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
306 306 fi
307 307 fi
308 308 # SET_ARCH not set
309 309 else
310 310 echo "error: Please set '32' or '64' as value for SET_ARCH"
311 311 exit 1
312 312 fi
313 313 # Device specific configuration and U-Boot configuration
314 314 case "$RPI_MODEL" in
315 315 0)
316 316 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
317 317 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
318 318 ;;
319 319 1)
320 320 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
321 321 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
322 322 ;;
323 323 1P)
324 324 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
325 325 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
326 326 ;;
327 327 2)
328 328 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
329 329 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
330 330 ;;
331 331 3)
332 332 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
333 333 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
334 334 ;;
335 335 3P)
336 336 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
337 337 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
338 338 ;;
339 339 *)
340 340 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
341 341 exit 1
342 342 ;;
343 343 esac
344 344
345 345 # Raspberry PI 0,3,3P with Bluetooth and Wifi onboard
346 346 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] ; then
347 347 # Include bluetooth packages on supported boards
348 348 if [ "$ENABLE_BLUETOOTH" = true ] ; then
349 349 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
350 350 fi
351 351 if [ "$ENABLE_WIRELESS" = true ] ; then
352 352 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,firmware-brcm80211"
353 353 fi
354 354 else # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
355 355 # Check if the internal wireless interface is not supported by the RPi model
356 356 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
357 357 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
358 358 exit 1
359 359 fi
360 360 fi
361 361
362 362 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
363 363 echo "error: You have to compile kernel sources, if you want to enable nexmon"
364 364 exit 1
365 365 fi
366 366
367 367 # Prepare date string for default image file name
368 368 DATE="$(date +%Y-%m-%d)"
369 369 if [ -z "$KERNEL_BRANCH" ] ; then
370 370 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
371 371 else
372 372 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
373 373 fi
374 374
375 375 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
376 376 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
377 377 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
378 378 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
379 379 exit 1
380 380 fi
381 381 fi
382 382
383 383 set +x
384 384
385 385 # Add cmake to compile videocore sources
386 386 if [ "$ENABLE_VIDEOCORE" = true ] ; then
387 387 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
388 388 fi
389 389
390 390 # Add deps for nexmon
391 391 if [ "$ENABLE_NEXMON" = true ] ; then
392 392 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf bison flex make autoconf automake build-essential libtool"
393 393 fi
394 394
395 395 # Add libncurses5 to enable kernel menuconfig
396 396 if [ "$KERNEL_MENUCONFIG" = true ] ; then
397 397 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
398 398 fi
399 399
400 400 # Add ccache compiler cache for (faster) kernel cross (re)compilation
401 401 if [ "$KERNEL_CCACHE" = true ] ; then
402 402 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
403 403 fi
404 404
405 405 # Add cryptsetup package to enable filesystem encryption
406 406 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
407 407 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
408 408 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
409 409
410 410 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
411 411 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
412 412 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
413 413 fi
414 414
415 415 if [ -z "$CRYPTFS_PASSWORD" ] ; then
416 416 echo "error: no password defined (CRYPTFS_PASSWORD)!"
417 417 exit 1
418 418 fi
419 419 ENABLE_INITRAMFS=true
420 420 fi
421 421
422 422 # Add initramfs generation tools
423 423 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
424 424 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
425 425 fi
426 426
427 427 # Add device-tree-compiler required for building the U-Boot bootloader
428 428 if [ "$ENABLE_UBOOT" = true ] ; then
429 429 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex,bc"
430 else
430 #else
431 431 # if [ "$ENABLE_UBOOTUSB" = true ] ; then
432 432 # echo "error: Enabling UBOOTUSB requires u-boot to be enabled"
433 433 # exit 1
434 434 # fi
435 435 fi
436 436
437 437 # Check if root SSH (v2) public key file exists
438 438 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
439 439 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
440 440 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
441 441 exit 1
442 442 fi
443 443 fi
444 444
445 445 # Check if $USER_NAME SSH (v2) public key file exists
446 446 if [ -n "$SSH_USER_PUB_KEY" ] ; then
447 447 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
448 448 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
449 449 exit 1
450 450 fi
451 451 fi
452 452
453 453 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
454 454 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
455 455 exit 1
456 456 fi
457 457
458 458 # Check if all required packages are installed on the build system
459 459 for package in $REQUIRED_PACKAGES ; do
460 460 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
461 461 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
462 462 fi
463 463 done
464 464
465 465 # If there are missing packages ask confirmation for install, or exit
466 466 if [ -n "$MISSING_PACKAGES" ] ; then
467 467 echo "the following packages needed by this script are not installed:"
468 468 echo "$MISSING_PACKAGES"
469 469
470 470 printf "\ndo you want to install the missing packages right now? [y/n] "
471 471 read -r confirm
472 472 [ "$confirm" != "y" ] && exit 1
473 473
474 474 # Make sure all missing required packages are installed
475 475 apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
476 476 fi
477 477
478 478 # Check if ./bootstrap.d directory exists
479 479 if [ ! -d "./bootstrap.d/" ] ; then
480 480 echo "error: './bootstrap.d' required directory not found!"
481 481 exit 1
482 482 fi
483 483
484 484 # Check if ./files directory exists
485 485 if [ ! -d "./files/" ] ; then
486 486 echo "error: './files' required directory not found!"
487 487 exit 1
488 488 fi
489 489
490 490 # Check if specified KERNELSRC_DIR directory exists
491 491 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
492 492 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
493 493 exit 1
494 494 fi
495 495
496 496 # Check if specified UBOOTSRC_DIR directory exists
497 497 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
498 498 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
499 499 exit 1
500 500 fi
501 501
502 502 # Check if specified VIDEOCORESRC_DIR directory exists
503 503 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
504 504 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
505 505 exit 1
506 506 fi
507 507
508 508 # Check if specified FBTURBOSRC_DIR directory exists
509 509 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
510 510 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
511 511 exit 1
512 512 fi
513 513
514 514 # Check if specified NEXMONSRC_DIR directory exists
515 515 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
516 516 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
517 517 exit 1
518 518 fi
519 519
520 520 # Check if specified CHROOT_SCRIPTS directory exists
521 521 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
522 522 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
523 523 exit 1
524 524 fi
525 525
526 526 # Check if specified device mapping already exists (will be used by cryptsetup)
527 527 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
528 528 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
529 529 exit 1
530 530 fi
531 531
532 532 # Don't clobber an old build
533 533 if [ -e "$BUILDDIR" ] ; then
534 534 echo "error: directory ${BUILDDIR} already exists, not proceeding"
535 535 exit 1
536 536 fi
537 537
538 538 # Setup chroot directory
539 539 mkdir -p "${R}"
540 540
541 541 # Check if build directory has enough of free disk space >512MB
542 542 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
543 543 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
544 544 exit 1
545 545 fi
546 546
547 547 set -x
548 548
549 549 # Call "cleanup" function on various signals and errors
550 550 trap cleanup 0 1 2 3 6
551 551
552 552 # Add required packages for the minbase installation
553 553 if [ "$ENABLE_MINBASE" = true ] ; then
554 554 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
555 555 fi
556 556
557 557 # Add parted package, required to get partprobe utility
558 558 if [ "$EXPANDROOT" = true ] ; then
559 559 APT_INCLUDES="${APT_INCLUDES},parted"
560 560 fi
561 561
562 562 # Add dbus package, recommended if using systemd
563 563 if [ "$ENABLE_DBUS" = true ] ; then
564 564 APT_INCLUDES="${APT_INCLUDES},dbus"
565 565 fi
566 566
567 567 # Add iptables IPv4/IPv6 package
568 568 if [ "$ENABLE_IPTABLES" = true ] ; then
569 569 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
570 570 fi
571 571 # Add apparmor for KERNEL_SECURITY
572 572 if [ "$KERNEL_SECURITY" = true ] ; then
573 573 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
574 574 fi
575 575
576 576 # Add openssh server package
577 577 if [ "$ENABLE_SSHD" = true ] ; then
578 578 APT_INCLUDES="${APT_INCLUDES},openssh-server"
579 579 fi
580 580
581 581 # Add alsa-utils package
582 582 if [ "$ENABLE_SOUND" = true ] ; then
583 583 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
584 584 fi
585 585
586 586 # Add rng-tools package
587 587 if [ "$ENABLE_HWRANDOM" = true ] ; then
588 588 APT_INCLUDES="${APT_INCLUDES},rng-tools"
589 589 fi
590 590
591 591 # Add fbturbo video driver
592 592 if [ "$ENABLE_FBTURBO" = true ] ; then
593 593 # Enable xorg package dependencies
594 594 ENABLE_XORG=true
595 595 fi
596 596
597 597 # Add user defined window manager package
598 598 if [ -n "$ENABLE_WM" ] ; then
599 599 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
600 600
601 601 # Enable xorg package dependencies
602 602 ENABLE_XORG=true
603 603 fi
604 604
605 605 # Add xorg package
606 606 if [ "$ENABLE_XORG" = true ] ; then
607 607 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
608 608 fi
609 609
610 610 # Replace selected packages with smaller clones
611 611 if [ "$ENABLE_REDUCE" = true ] ; then
612 612 # Add levee package instead of vim-tiny
613 613 if [ "$REDUCE_VIM" = true ] ; then
614 614 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
615 615 fi
616 616
617 617 # Add dropbear package instead of openssh-server
618 618 if [ "$REDUCE_SSHD" = true ] ; then
619 619 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
620 620 fi
621 621 fi
622 622
623 623 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
624 624 if [ "$ENABLE_SYSVINIT" = false ] ; then
625 625 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
626 626 fi
627 627
628 628 # Configure kernel sources if no KERNELSRC_DIR
629 629 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
630 630 KERNELSRC_CONFIG=true
631 631 fi
632 632
633 633 # Configure reduced kernel
634 634 if [ "$KERNEL_REDUCE" = true ] ; then
635 635 KERNELSRC_CONFIG=false
636 636 fi
637 637
638 638 # Configure qemu compatible kernel
639 639 if [ "$ENABLE_QEMU" = true ] ; then
640 640 DTB_FILE=vexpress-v2p-ca15_a7.dtb
641 641 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
642 642 KERNEL_DEFCONFIG="vexpress_defconfig"
643 643 if [ "$KERNEL_MENUCONFIG" = false ] ; then
644 644 KERNEL_OLDDEFCONFIG=true
645 645 fi
646 646 fi
647 647
648 648 # Execute bootstrap scripts
649 649 for SCRIPT in bootstrap.d/*.sh; do
650 650 head -n 3 "$SCRIPT"
651 651 . "$SCRIPT"
652 652 done
653 653
654 654 ## Execute custom bootstrap scripts
655 655 if [ -d "custom.d" ] ; then
656 656 for SCRIPT in custom.d/*.sh; do
657 657 . "$SCRIPT"
658 658 done
659 659 fi
660 660
661 661 # Execute custom scripts inside the chroot
662 662 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
663 663 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
664 664 chroot_exec /bin/bash -x <<'EOF'
665 665 for SCRIPT in /chroot_scripts/* ; do
666 666 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
667 667 $SCRIPT
668 668 fi
669 669 done
670 670 EOF
671 671 rm -rf "${R}/chroot_scripts"
672 672 fi
673 673
674 674 # Remove c/c++ build environment from the chroot
675 675 chroot_remove_cc
676 676
677 677 # Generate required machine-id
678 678 MACHINE_ID=$(dbus-uuidgen)
679 679 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
680 680 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
681 681
682 682 # APT Cleanup
683 683 chroot_exec apt-get -y clean
684 684 chroot_exec apt-get -y autoclean
685 685 chroot_exec apt-get -y autoremove
686 686
687 687 # Unmount mounted filesystems
688 688 umount -l "${R}/proc"
689 689 umount -l "${R}/sys"
690 690
691 691 # Clean up directories
692 692 rm -rf "${R}/run/*"
693 693 rm -rf "${R}/tmp/*"
694 694
695 695 # Clean up files
696 696 rm -f "${ETC_DIR}/ssh/ssh_host_*"
697 697 rm -f "${ETC_DIR}/dropbear/dropbear_*"
698 698 rm -f "${ETC_DIR}/apt/sources.list.save"
699 699 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
700 700 rm -f "${ETC_DIR}/*-"
701 701 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
702 702 rm -f "${ETC_DIR}/resolv.conf"
703 703 rm -f "${R}/root/.bash_history"
704 704 rm -f "${R}/var/lib/urandom/random-seed"
705 705 rm -f "${R}/initrd.img"
706 706 rm -f "${R}/vmlinuz"
707 707 rm -f "${R}${QEMU_BINARY}"
708 708
709 709 if [ "$ENABLE_QEMU" = true ] ; then
710 710 # Setup QEMU directory
711 711 mkdir "${BASEDIR}/qemu"
712 712
713 713 # Copy kernel image to QEMU directory
714 714 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
715 715
716 716 # Copy kernel config to QEMU directory
717 717 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
718 718
719 719 # Copy kernel dtbs to QEMU directory
720 720 for dtb in "${BOOT_DIR}/"*.dtb ; do
721 721 if [ -f "${dtb}" ] ; then
722 722 install_readonly "${dtb}" "${BASEDIR}/qemu/"
723 723 fi
724 724 done
725 725
726 726 # Copy kernel overlays to QEMU directory
727 727 if [ -d "${BOOT_DIR}/overlays" ] ; then
728 728 # Setup overlays dtbs directory
729 729 mkdir "${BASEDIR}/qemu/overlays"
730 730
731 731 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
732 732 if [ -f "${dtb}" ] ; then
733 733 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
734 734 fi
735 735 done
736 736 fi
737 737
738 738 # Copy u-boot files to QEMU directory
739 739 if [ "$ENABLE_UBOOT" = true ] ; then
740 740 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
741 741 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
742 742 fi
743 743 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
744 744 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
745 745 fi
746 746 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
747 747 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
748 748 fi
749 749 fi
750 750
751 751 # Copy initramfs to QEMU directory
752 752 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
753 753 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
754 754 fi
755 755 fi
756 756
757 757 # Calculate size of the chroot directory in KB
758 758 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
759 759
760 760 # Calculate the amount of needed 512 Byte sectors
761 761 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
762 762 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
763 763 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
764 764
765 765 # The root partition is EXT4
766 766 # This means more space than the actual used space of the chroot is used.
767 767 # As overhead for journaling and reserved blocks 35% are added.
768 768 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
769 769
770 770 # Calculate required image size in 512 Byte sectors
771 771 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
772 772
773 773 # Prepare image file
774 774 if [ "$ENABLE_SPLITFS" = true ] ; then
775 775 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
776 776 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
777 777 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
778 778 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
779 779
780 780 # Write firmware/boot partition tables
781 781 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
782 782 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
783 783 EOM
784 784
785 785 # Write root partition table
786 786 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
787 787 ${TABLE_SECTORS},${ROOT_SECTORS},83
788 788 EOM
789 789
790 790 # Setup temporary loop devices
791 791 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME"-frmw.img)"
792 792 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
793 793 else # ENABLE_SPLITFS=false
794 794 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
795 795 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
796 796
797 797 # Write partition table
798 798 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
799 799 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
800 800 ${ROOT_OFFSET},${ROOT_SECTORS},83
801 801 EOM
802 802
803 803 # Setup temporary loop devices
804 804 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show "$IMAGE_NAME".img)"
805 805 ROOT_LOOP="$(losetup -o 65M -f --show "$IMAGE_NAME".img)"
806 806 fi
807 807
808 808 if [ "$ENABLE_CRYPTFS" = true ] ; then
809 809 # Create dummy ext4 fs
810 810 mkfs.ext4 "$ROOT_LOOP"
811 811
812 812 # Setup password keyfile
813 813 touch .password
814 814 chmod 600 .password
815 815 echo -n ${CRYPTFS_PASSWORD} > .password
816 816
817 817 # Initialize encrypted partition
818 818 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
819 819
820 820 # Open encrypted partition and setup mapping
821 821 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
822 822
823 823 # Secure delete password keyfile
824 824 shred -zu .password
825 825
826 826 # Update temporary loop device
827 827 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
828 828
829 829 # Wipe encrypted partition (encryption cipher is used for randomness)
830 830 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
831 831 fi
832 832
833 833 # Build filesystems
834 834 mkfs.vfat "$FRMW_LOOP"
835 835 mkfs.ext4 "$ROOT_LOOP"
836 836
837 837 # Mount the temporary loop devices
838 838 mkdir -p "$BUILDDIR/mount"
839 839 mount "$ROOT_LOOP" "$BUILDDIR/mount"
840 840
841 841 mkdir -p "$BUILDDIR/mount/boot/firmware"
842 842 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
843 843
844 844 # Copy all files from the chroot to the loop device mount point directory
845 845 rsync -a "${R}/" "$BUILDDIR/mount/"
846 846
847 847 # Unmount all temporary loop devices and mount points
848 848 cleanup
849 849
850 850 # Create block map file(s) of image(s)
851 851 if [ "$ENABLE_SPLITFS" = true ] ; then
852 852 # Create block map files for "bmaptool"
853 853 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
854 854 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
855 855
856 856 # Image was successfully created
857 857 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
858 858 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
859 859 else
860 860 # Create block map file for "bmaptool"
861 861 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
862 862
863 863 # Image was successfully created
864 864 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
865 865
866 866 # Create qemu qcow2 image
867 867 if [ "$ENABLE_QEMU" = true ] ; then
868 868 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
869 869 QEMU_SIZE=16G
870 870
871 871 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
872 872 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
873 873
874 874 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
875 875 fi
876 876 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant